---
title: Create an incident
description: Datadog, the leading service for cloud-scale monitoring.
breadcrumbs: Docs > API Reference > Incidents
---

# Create an incident{% #create-an-incident %}
Copy pageCopied
{% tab title="v2" %}
**Note**: This endpoint is in public beta. If you have any feedback, contact [Datadog support](https://docs.datadoghq.com/help/).
| Datadog site      | API endpoint                                        |
| ----------------- | --------------------------------------------------- |
| ap1.datadoghq.com | POST https://api.ap1.datadoghq.com/api/v2/incidents |
| ap2.datadoghq.com | POST https://api.ap2.datadoghq.com/api/v2/incidents |
| app.datadoghq.eu  | POST https://api.datadoghq.eu/api/v2/incidents      |
| app.ddog-gov.com  | POST https://api.ddog-gov.com/api/v2/incidents      |
| us2.ddog-gov.com  | POST https://api.us2.ddog-gov.com/api/v2/incidents  |
| app.datadoghq.com | POST https://api.datadoghq.com/api/v2/incidents     |
| us3.datadoghq.com | POST https://api.us3.datadoghq.com/api/v2/incidents |
| us5.datadoghq.com | POST https://api.us5.datadoghq.com/api/v2/incidents |

### Overview

Create an incident. This endpoint requires the `incident_write` permission.

OAuth apps require the `incident_write` authorization [scope](https://docs.datadoghq.com/api/latest/scopes.md#incidents) to access this endpoint.



### Request

#### Body Data (required)

Incident payload.

{% tab title="Model" %}

| Parent field         | Field                               | Type            | Description                                                                                                                    |
| -------------------- | ----------------------------------- | --------------- | ------------------------------------------------------------------------------------------------------------------------------ |
|                      | data [*required*]              | object          | Incident data for a create request.                                                                                            |
| data                 | attributes [*required*]        | object          | The incident's attributes for a create request.                                                                                |
| attributes           | customer_impact_scope               | string          | Required if `customer_impacted:"true"`. A summary of the impact customers experienced during the incident.                     |
| attributes           | customer_impacted [*required*] | boolean         | A flag indicating whether the incident caused customer impact.                                                                 |
| attributes           | fields                              | object          | A condensed view of the user-defined fields for which to create initial selections.                                            |
| additionalProperties | <any-key>                           |  <oneOf>   | Dynamic fields for which selections can be made, with field names as keys.                                                     |
| <any-key>            | Option 1                            | object          | A field with a single value selected.                                                                                          |
| Option 1             | type                                | enum            | Type of the single value field definitions. Allowed enum values: `dropdown,textbox`                                            |
| Option 1             | value                               | string          | The single value selected for this field.                                                                                      |
| <any-key>            | Option 2                            | object          | A field with potentially multiple values selected.                                                                             |
| Option 2             | type                                | enum            | Type of the multiple value field definitions. Allowed enum values: `multiselect,textarray,metrictag,autocomplete`              |
| Option 2             | value                               | [string]        | The multiple values selected for this field.                                                                                   |
| attributes           | incident_type_uuid                  | string          | A unique identifier that represents an incident type. The default incident type will be used if this property is not provided. |
| attributes           | initial_cells                       | [ <oneOf>] | An array of initial timeline cells to be placed at the beginning of the incident timeline.                                     |
| initial_cells        | Option 1                            | object          | Timeline cell data for Markdown timeline cells for a create request.                                                           |
| Option 1             | cell_type [*required*]         | enum            | Type of the Markdown timeline cell. Allowed enum values: `markdown`                                                            |
| Option 1             | content [*required*]           | object          | The Markdown timeline cell contents.                                                                                           |
| content              | content                             | string          | The Markdown content of the cell.                                                                                              |
| Option 1             | important                           | boolean         | A flag indicating whether the timeline cell is important and should be highlighted.                                            |
| attributes           | is_test                             | boolean         | A flag indicating whether the incident is a test incident.                                                                     |
| attributes           | notification_handles                | [object]        | Notification handles that will be notified of the incident at creation.                                                        |
| notification_handles | display_name                        | string          | The name of the notified handle.                                                                                               |
| notification_handles | handle                              | string          | The handle used for the notification. This includes an email address, Slack channel, or workflow.                              |
| attributes           | title [*required*]             | string          | The title of the incident, which summarizes what happened.                                                                     |
| data                 | relationships                       | object          | The relationships the incident will have with other resources once created.                                                    |
| relationships        | commander_user [*required*]    | object          | Relationship to user.                                                                                                          |
| commander_user       | data [*required*]              | object          | Relationship to user object.                                                                                                   |
| data                 | id [*required*]                | string          | A unique identifier that represents the user.                                                                                  |
| data                 | type [*required*]              | enum            | Users resource type. Allowed enum values: `users`                                                                              |
| data                 | type [*required*]              | enum            | Incident resource type. Allowed enum values: `incidents`                                                                       |

{% /tab %}

{% tab title="Example" %}

```json
{
  "data": {
    "type": "incidents",
    "attributes": {
      "title": "Example-Incident",
      "customer_impacted": false,
      "fields": {
        "state": {
          "type": "dropdown",
          "value": "resolved"
        }
      }
    },
    "relationships": {
      "commander_user": {
        "data": {
          "type": "users",
          "id": "string"
        }
      }
    }
  }
}
```

{% /tab %}

### Response

{% tab title="201" %}
CREATED
{% tab title="Model" %}
Response with an incident.

| Parent field          | Field                           | Type            | Description                                                                                                                                             |
| --------------------- | ------------------------------- | --------------- | ------------------------------------------------------------------------------------------------------------------------------------------------------- |
|                       | data [*required*]          | object          | Incident data from a response.                                                                                                                          |
| data                  | attributes                      | object          | The incident's attributes from a response.                                                                                                              |
| attributes            | archived                        | date-time       | Timestamp of when the incident was archived.                                                                                                            |
| attributes            | case_id                         | int64           | The incident case id.                                                                                                                                   |
| attributes            | created                         | date-time       | Timestamp when the incident was created.                                                                                                                |
| attributes            | customer_impact_duration        | int64           | Length of the incident's customer impact in seconds. Equals the difference between `customer_impact_start` and `customer_impact_end`.                   |
| attributes            | customer_impact_end             | date-time       | Timestamp when customers were no longer impacted by the incident.                                                                                       |
| attributes            | customer_impact_scope           | string          | A summary of the impact customers experienced during the incident.                                                                                      |
| attributes            | customer_impact_start           | date-time       | Timestamp when customers began being impacted by the incident.                                                                                          |
| attributes            | customer_impacted               | boolean         | A flag indicating whether the incident caused customer impact.                                                                                          |
| attributes            | declared                        | date-time       | Timestamp when the incident was declared.                                                                                                               |
| attributes            | declared_by                     | object          | Incident's non Datadog creator.                                                                                                                         |
| declared_by           | image_48_px                     | string          | Non Datadog creator `48px` image.                                                                                                                       |
| declared_by           | name                            | string          | Non Datadog creator name.                                                                                                                               |
| attributes            | declared_by_uuid                | string          | UUID of the user who declared the incident.                                                                                                             |
| attributes            | detected                        | date-time       | Timestamp when the incident was detected.                                                                                                               |
| attributes            | fields                          | object          | A condensed view of the user-defined fields attached to incidents.                                                                                      |
| additionalProperties  | <any-key>                       |  <oneOf>   | Dynamic fields for which selections can be made, with field names as keys.                                                                              |
| <any-key>             | Option 1                        | object          | A field with a single value selected.                                                                                                                   |
| Option 1              | type                            | enum            | Type of the single value field definitions. Allowed enum values: `dropdown,textbox`                                                                     |
| Option 1              | value                           | string          | The single value selected for this field.                                                                                                               |
| <any-key>             | Option 2                        | object          | A field with potentially multiple values selected.                                                                                                      |
| Option 2              | type                            | enum            | Type of the multiple value field definitions. Allowed enum values: `multiselect,textarray,metrictag,autocomplete`                                       |
| Option 2              | value                           | [string]        | The multiple values selected for this field.                                                                                                            |
| attributes            | incident_type_uuid              | string          | A unique identifier that represents an incident type.                                                                                                   |
| attributes            | is_test                         | boolean         | A flag indicating whether the incident is a test incident.                                                                                              |
| attributes            | modified                        | date-time       | Timestamp when the incident was last modified.                                                                                                          |
| attributes            | non_datadog_creator             | object          | Incident's non Datadog creator.                                                                                                                         |
| non_datadog_creator   | image_48_px                     | string          | Non Datadog creator `48px` image.                                                                                                                       |
| non_datadog_creator   | name                            | string          | Non Datadog creator name.                                                                                                                               |
| attributes            | notification_handles            | [object]        | Notification handles that will be notified of the incident during update.                                                                               |
| notification_handles  | display_name                    | string          | The name of the notified handle.                                                                                                                        |
| notification_handles  | handle                          | string          | The handle used for the notification. This includes an email address, Slack channel, or workflow.                                                       |
| attributes            | public_id                       | int64           | The monotonically increasing integer ID for the incident.                                                                                               |
| attributes            | resolved                        | date-time       | Timestamp when the incident's state was last changed from active or stable to resolved or completed.                                                    |
| attributes            | severity                        | enum            | The incident severity. Allowed enum values: `UNKNOWN,SEV-0,SEV-1,SEV-2,SEV-3,SEV-4,SEV-5`                                                               |
| attributes            | state                           | string          | The state incident.                                                                                                                                     |
| attributes            | time_to_detect                  | int64           | The amount of time in seconds to detect the incident. Equals the difference between `customer_impact_start` and `detected`.                             |
| attributes            | time_to_internal_response       | int64           | The amount of time in seconds to call incident after detection. Equals the difference of `detected` and `created`.                                      |
| attributes            | time_to_repair                  | int64           | The amount of time in seconds to resolve customer impact after detecting the issue. Equals the difference between `customer_impact_end` and `detected`. |
| attributes            | time_to_resolve                 | int64           | The amount of time in seconds to resolve the incident after it was created. Equals the difference between `created` and `resolved`.                     |
| attributes            | title [*required*]         | string          | The title of the incident, which summarizes what happened.                                                                                              |
| attributes            | visibility                      | string          | The incident visibility status.                                                                                                                         |
| data                  | id [*required*]            | string          | The incident's ID.                                                                                                                                      |
| data                  | relationships                   | object          | The incident's relationships from a response.                                                                                                           |
| relationships         | attachments                     | object          | A relationship reference for attachments.                                                                                                               |
| attachments           | data [*required*]          | [object]        | An array of incident attachments.                                                                                                                       |
| data                  | id [*required*]            | string          | A unique identifier that represents the attachment.                                                                                                     |
| data                  | type [*required*]          | enum            | The incident attachment resource type. Allowed enum values: `incident_attachments`                                                                      |
| relationships         | commander_user                  | object          | Relationship to user.                                                                                                                                   |
| commander_user        | data [*required*]          | object          | Relationship to user object.                                                                                                                            |
| data                  | id [*required*]            | string          | A unique identifier that represents the user.                                                                                                           |
| data                  | type [*required*]          | enum            | Users resource type. Allowed enum values: `users`                                                                                                       |
| relationships         | created_by_user                 | object          | Relationship to user.                                                                                                                                   |
| created_by_user       | data [*required*]          | object          | Relationship to user object.                                                                                                                            |
| data                  | id [*required*]            | string          | A unique identifier that represents the user.                                                                                                           |
| data                  | type [*required*]          | enum            | Users resource type. Allowed enum values: `users`                                                                                                       |
| relationships         | declared_by_user                | object          | Relationship to user.                                                                                                                                   |
| declared_by_user      | data [*required*]          | object          | Relationship to user object.                                                                                                                            |
| data                  | id [*required*]            | string          | A unique identifier that represents the user.                                                                                                           |
| data                  | type [*required*]          | enum            | Users resource type. Allowed enum values: `users`                                                                                                       |
| relationships         | impacts                         | object          | Relationship to impacts.                                                                                                                                |
| impacts               | data [*required*]          | [object]        | An array of incident impacts.                                                                                                                           |
| data                  | id [*required*]            | string          | A unique identifier that represents the impact.                                                                                                         |
| data                  | type [*required*]          | enum            | The incident impacts type. Allowed enum values: `incident_impacts`                                                                                      |
| relationships         | integrations                    | object          | A relationship reference for multiple integration metadata objects.                                                                                     |
| integrations          | data [*required*]          | [object]        | Integration metadata relationship array                                                                                                                 |
| data                  | id [*required*]            | string          | A unique identifier that represents the integration metadata.                                                                                           |
| data                  | type [*required*]          | enum            | Integration metadata resource type. Allowed enum values: `incident_integrations`                                                                        |
| relationships         | last_modified_by_user           | object          | Relationship to user.                                                                                                                                   |
| last_modified_by_user | data [*required*]          | object          | Relationship to user object.                                                                                                                            |
| data                  | id [*required*]            | string          | A unique identifier that represents the user.                                                                                                           |
| data                  | type [*required*]          | enum            | Users resource type. Allowed enum values: `users`                                                                                                       |
| relationships         | responders                      | object          | Relationship to incident responders.                                                                                                                    |
| responders            | data [*required*]          | [object]        | An array of incident responders.                                                                                                                        |
| data                  | id [*required*]            | string          | A unique identifier that represents the responder.                                                                                                      |
| data                  | type [*required*]          | enum            | The incident responders type. Allowed enum values: `incident_responders`                                                                                |
| relationships         | user_defined_fields             | object          | Relationship to incident user defined fields.                                                                                                           |
| user_defined_fields   | data [*required*]          | [object]        | An array of user defined fields.                                                                                                                        |
| data                  | id [*required*]            | string          | A unique identifier that represents the responder.                                                                                                      |
| data                  | type [*required*]          | enum            | The incident user defined fields type. Allowed enum values: `user_defined_field`                                                                        |
| data                  | type [*required*]          | enum            | Incident resource type. Allowed enum values: `incidents`                                                                                                |
|                       | included                        | [ <oneOf>] | Included related resources that the user requested.                                                                                                     |
| included              | Option 1                        | object          | User object returned by the API.                                                                                                                        |
| Option 1              | attributes                      | object          | Attributes of user object returned by the API.                                                                                                          |
| attributes            | email                           | string          | Email of the user.                                                                                                                                      |
| attributes            | handle                          | string          | Handle of the user.                                                                                                                                     |
| attributes            | icon                            | string          | URL of the user's icon.                                                                                                                                 |
| attributes            | name                            | string          | Name of the user.                                                                                                                                       |
| attributes            | uuid                            | string          | UUID of the user.                                                                                                                                       |
| Option 1              | id                              | string          | ID of the user.                                                                                                                                         |
| Option 1              | type                            | enum            | Users resource type. Allowed enum values: `users`                                                                                                       |
| included              | Option 2                        | object          | Attachment data from a response.                                                                                                                        |
| Option 2              | attributes [*required*]    | object          | The attachment's attributes.                                                                                                                            |
| attributes            | attachment                      | object          | The attachment object.                                                                                                                                  |
| attachment            | documentUrl                     | string          | The URL of the attachment.                                                                                                                              |
| attachment            | title                           | string          | The title of the attachment.                                                                                                                            |
| attributes            | attachment_type                 | enum            | The type of the attachment. Allowed enum values: `postmortem,link`                                                                                      |
| attributes            | modified                        | date-time       | Timestamp when the attachment was last modified.                                                                                                        |
| Option 2              | id [*required*]            | string          | The unique identifier of the attachment.                                                                                                                |
| Option 2              | relationships [*required*] | object          | The attachment's resource relationships.                                                                                                                |
| relationships         | incident                        | object          | Relationship to incident.                                                                                                                               |
| incident              | data [*required*]          | object          | Relationship to incident object.                                                                                                                        |
| data                  | id [*required*]            | string          | A unique identifier that represents the incident.                                                                                                       |
| data                  | type [*required*]          | enum            | Incident resource type. Allowed enum values: `incidents`                                                                                                |
| relationships         | last_modified_by_user           | object          | Relationship to user.                                                                                                                                   |
| last_modified_by_user | data [*required*]          | object          | Relationship to user object.                                                                                                                            |
| data                  | id [*required*]            | string          | A unique identifier that represents the user.                                                                                                           |
| data                  | type [*required*]          | enum            | Users resource type. Allowed enum values: `users`                                                                                                       |
| Option 2              | type [*required*]          | enum            | The incident attachment resource type. Allowed enum values: `incident_attachments`                                                                      |

{% /tab %}

{% tab title="Example" %}

```json
{
  "data": {
    "attributes": {
      "archived": "2019-09-19T10:00:00.000Z",
      "case_id": "integer",
      "created": "2019-09-19T10:00:00.000Z",
      "customer_impact_duration": "integer",
      "customer_impact_end": "2019-09-19T10:00:00.000Z",
      "customer_impact_scope": "An example customer impact scope",
      "customer_impact_start": "2019-09-19T10:00:00.000Z",
      "customer_impacted": false,
      "declared": "2019-09-19T10:00:00.000Z",
      "declared_by": {
        "image_48_px": "string",
        "name": "string"
      },
      "declared_by_uuid": "string",
      "detected": "2019-09-19T10:00:00.000Z",
      "fields": {
        "<any-key>": "undefined"
      },
      "incident_type_uuid": "00000000-0000-0000-0000-000000000000",
      "is_test": false,
      "modified": "2019-09-19T10:00:00.000Z",
      "non_datadog_creator": {
        "image_48_px": "string",
        "name": "string"
      },
      "notification_handles": [
        {
          "display_name": "Jane Doe",
          "handle": "@test.user@test.com"
        }
      ],
      "public_id": 1,
      "resolved": "2019-09-19T10:00:00.000Z",
      "severity": "UNKNOWN",
      "state": "string",
      "time_to_detect": "integer",
      "time_to_internal_response": "integer",
      "time_to_repair": "integer",
      "time_to_resolve": "integer",
      "title": "A test incident title",
      "visibility": "string"
    },
    "id": "00000000-0000-0000-1234-000000000000",
    "relationships": {
      "attachments": {
        "data": [
          {
            "id": "00000000-0000-abcd-1000-000000000000",
            "type": "incident_attachments"
          }
        ]
      },
      "commander_user": {
        "data": {
          "id": "00000000-0000-0000-0000-000000000000",
          "type": "users"
        }
      },
      "created_by_user": {
        "data": {
          "id": "00000000-0000-0000-2345-000000000000",
          "type": "users"
        }
      },
      "declared_by_user": {
        "data": {
          "id": "00000000-0000-0000-2345-000000000000",
          "type": "users"
        }
      },
      "impacts": {
        "data": [
          {
            "id": "00000000-0000-0000-2345-000000000000",
            "type": "incident_impacts"
          }
        ]
      },
      "integrations": {
        "data": [
          {
            "id": "00000000-abcd-0001-0000-000000000000",
            "type": "incident_integrations"
          }
        ]
      },
      "last_modified_by_user": {
        "data": {
          "id": "00000000-0000-0000-2345-000000000000",
          "type": "users"
        }
      },
      "responders": {
        "data": [
          {
            "id": "00000000-0000-0000-2345-000000000000",
            "type": "incident_responders"
          }
        ]
      },
      "user_defined_fields": {
        "data": [
          {
            "id": "00000000-0000-0000-2345-000000000000",
            "type": "user_defined_field"
          }
        ]
      }
    },
    "type": "incidents"
  },
  "included": [
    {
      "attributes": {
        "email": "string",
        "handle": "string",
        "icon": "string",
        "name": "string",
        "uuid": "string"
      },
      "id": "string",
      "type": "users"
    }
  ]
}
```

{% /tab %}

{% /tab %}

{% tab title="400" %}
Bad Request
{% tab title="Model" %}
API error response.

| Field                    | Type     | Description       |
| ------------------------ | -------- | ----------------- |
| errors [*required*] | [string] | A list of errors. |

{% /tab %}

{% tab title="Example" %}

```json
{
  "errors": [
    "Bad Request"
  ]
}
```

{% /tab %}

{% /tab %}

{% tab title="401" %}
Unauthorized
{% tab title="Model" %}
API error response.

| Field                    | Type     | Description       |
| ------------------------ | -------- | ----------------- |
| errors [*required*] | [string] | A list of errors. |

{% /tab %}

{% tab title="Example" %}

```json
{
  "errors": [
    "Bad Request"
  ]
}
```

{% /tab %}

{% /tab %}

{% tab title="403" %}
Forbidden
{% tab title="Model" %}
API error response.

| Field                    | Type     | Description       |
| ------------------------ | -------- | ----------------- |
| errors [*required*] | [string] | A list of errors. |

{% /tab %}

{% tab title="Example" %}

```json
{
  "errors": [
    "Bad Request"
  ]
}
```

{% /tab %}

{% /tab %}

{% tab title="404" %}
Not Found
{% tab title="Model" %}
API error response.

| Field                    | Type     | Description       |
| ------------------------ | -------- | ----------------- |
| errors [*required*] | [string] | A list of errors. |

{% /tab %}

{% tab title="Example" %}

```json
{
  "errors": [
    "Bad Request"
  ]
}
```

{% /tab %}

{% /tab %}

{% tab title="429" %}
Too many requests
{% tab title="Model" %}
API error response.

| Field                    | Type     | Description       |
| ------------------------ | -------- | ----------------- |
| errors [*required*] | [string] | A list of errors. |

{% /tab %}

{% tab title="Example" %}

```json
{
  "errors": [
    "Bad Request"
  ]
}
```

{% /tab %}

{% /tab %}

### Code Example

##### 
                          \## default
# 
 \# Curl command curl -X POST "https://api.datadoghq.com/api/v2/incidents" \
-H "Accept: application/json" \
-H "Content-Type: application/json" \
-H "DD-API-KEY: ${DD_API_KEY}" \
-H "DD-APPLICATION-KEY: ${DD_APP_KEY}" \
-d @- << EOF
{
  "data": {
    "attributes": {
      "customer_impact_scope": "Example customer impact scope",
      "customer_impacted": false,
      "fields": {
        "severity": {
          "type": "dropdown",
          "value": "SEV-5"
        }
      },
      "incident_type_uuid": "00000000-0000-0000-0000-000000000000",
      "initial_cells": [
        {
          "cell_type": "markdown",
          "content": {
            "content": "An example timeline cell message."
          },
          "important": false
        }
      ],
      "is_test": false,
      "notification_handles": [
        {
          "display_name": "Jane Doe",
          "handle": "@user@email.com"
        },
        {
          "display_name": "Slack Channel",
          "handle": "@slack-channel"
        },
        {
          "display_name": "Incident Workflow",
          "handle": "@workflow-from-incident"
        }
      ],
      "title": "A test incident title"
    },
    "relationships": {
      "commander_user": {
        "data": {
          "id": "00000000-0000-0000-0000-000000000000",
          "type": "users"
        }
      }
    },
    "type": "incidents"
  }
}
EOF 
                        
##### 

```go
// Create an incident returns "CREATED" response

package main

import (
	"context"
	"encoding/json"
	"fmt"
	"os"

	"github.com/DataDog/datadog-api-client-go/v2/api/datadog"
	"github.com/DataDog/datadog-api-client-go/v2/api/datadogV2"
)

func main() {
	// there is a valid "user" in the system
	UserDataID := os.Getenv("USER_DATA_ID")

	body := datadogV2.IncidentCreateRequest{
		Data: datadogV2.IncidentCreateData{
			Type: datadogV2.INCIDENTTYPE_INCIDENTS,
			Attributes: datadogV2.IncidentCreateAttributes{
				Title:            "Example-Incident",
				CustomerImpacted: false,
				Fields: map[string]datadogV2.IncidentFieldAttributes{
					"state": datadogV2.IncidentFieldAttributes{
						IncidentFieldAttributesSingleValue: &datadogV2.IncidentFieldAttributesSingleValue{
							Type:  datadogV2.INCIDENTFIELDATTRIBUTESSINGLEVALUETYPE_DROPDOWN.Ptr(),
							Value: *datadog.NewNullableString(datadog.PtrString("resolved")),
						}},
				},
			},
			Relationships: &datadogV2.IncidentCreateRelationships{
				CommanderUser: *datadogV2.NewNullableNullableRelationshipToUser(&datadogV2.NullableRelationshipToUser{
					Data: *datadogV2.NewNullableNullableRelationshipToUserData(&datadogV2.NullableRelationshipToUserData{
						Type: datadogV2.USERSTYPE_USERS,
						Id:   UserDataID,
					}),
				}),
			},
		},
	}
	ctx := datadog.NewDefaultContext(context.Background())
	configuration := datadog.NewConfiguration()
	configuration.SetUnstableOperationEnabled("v2.CreateIncident", true)
	apiClient := datadog.NewAPIClient(configuration)
	api := datadogV2.NewIncidentsApi(apiClient)
	resp, r, err := api.CreateIncident(ctx, body)

	if err != nil {
		fmt.Fprintf(os.Stderr, "Error when calling `IncidentsApi.CreateIncident`: %v\n", err)
		fmt.Fprintf(os.Stderr, "Full HTTP response: %v\n", r)
	}

	responseContent, _ := json.MarshalIndent(resp, "", "  ")
	fmt.Fprintf(os.Stdout, "Response from `IncidentsApi.CreateIncident`:\n%s\n", responseContent)
}
```

#### Instructions

First [install the library and its dependencies](https://docs.datadoghq.com/api/latest.md?code-lang=go) and then save the example to `main.go` and run following commands:
    DD_SITE="datadoghq.com" DD_API_KEY="<DD_API_KEY>" DD_APP_KEY="<DD_APP_KEY>" go run "main.go"
##### 

```java
// Create an incident returns "CREATED" response

import com.datadog.api.client.ApiClient;
import com.datadog.api.client.ApiException;
import com.datadog.api.client.v2.api.IncidentsApi;
import com.datadog.api.client.v2.model.IncidentCreateAttributes;
import com.datadog.api.client.v2.model.IncidentCreateData;
import com.datadog.api.client.v2.model.IncidentCreateRelationships;
import com.datadog.api.client.v2.model.IncidentCreateRequest;
import com.datadog.api.client.v2.model.IncidentFieldAttributes;
import com.datadog.api.client.v2.model.IncidentFieldAttributesSingleValue;
import com.datadog.api.client.v2.model.IncidentFieldAttributesSingleValueType;
import com.datadog.api.client.v2.model.IncidentResponse;
import com.datadog.api.client.v2.model.IncidentType;
import com.datadog.api.client.v2.model.NullableRelationshipToUser;
import com.datadog.api.client.v2.model.NullableRelationshipToUserData;
import com.datadog.api.client.v2.model.UsersType;
import java.util.Map;

public class Example {
  public static void main(String[] args) {
    ApiClient defaultClient = ApiClient.getDefaultApiClient();
    defaultClient.setUnstableOperationEnabled("v2.createIncident", true);
    IncidentsApi apiInstance = new IncidentsApi(defaultClient);

    // there is a valid "user" in the system
    String USER_DATA_ID = System.getenv("USER_DATA_ID");

    IncidentCreateRequest body =
        new IncidentCreateRequest()
            .data(
                new IncidentCreateData()
                    .type(IncidentType.INCIDENTS)
                    .attributes(
                        new IncidentCreateAttributes()
                            .title("Example-Incident")
                            .customerImpacted(false)
                            .fields(
                                Map.ofEntries(
                                    Map.entry(
                                        "state",
                                        new IncidentFieldAttributes(
                                            new IncidentFieldAttributesSingleValue()
                                                .type(
                                                    IncidentFieldAttributesSingleValueType.DROPDOWN)
                                                .value("resolved"))))))
                    .relationships(
                        new IncidentCreateRelationships()
                            .commanderUser(
                                new NullableRelationshipToUser()
                                    .data(
                                        new NullableRelationshipToUserData()
                                            .type(UsersType.USERS)
                                            .id(USER_DATA_ID)))));

    try {
      IncidentResponse result = apiInstance.createIncident(body);
      System.out.println(result);
    } catch (ApiException e) {
      System.err.println("Exception when calling IncidentsApi#createIncident");
      System.err.println("Status code: " + e.getCode());
      System.err.println("Reason: " + e.getResponseBody());
      System.err.println("Response headers: " + e.getResponseHeaders());
      e.printStackTrace();
    }
  }
}
```

#### Instructions

First [install the library and its dependencies](https://docs.datadoghq.com/api/latest.md?code-lang=java) and then save the example to `Example.java` and run following commands:
    DD_SITE="datadoghq.com" DD_API_KEY="<DD_API_KEY>" DD_APP_KEY="<DD_APP_KEY>" java "Example.java"
##### 

```python
"""
Create an incident returns "CREATED" response
"""

from os import environ
from datadog_api_client import ApiClient, Configuration
from datadog_api_client.v2.api.incidents_api import IncidentsApi
from datadog_api_client.v2.model.incident_create_attributes import IncidentCreateAttributes
from datadog_api_client.v2.model.incident_create_data import IncidentCreateData
from datadog_api_client.v2.model.incident_create_relationships import IncidentCreateRelationships
from datadog_api_client.v2.model.incident_create_request import IncidentCreateRequest
from datadog_api_client.v2.model.incident_field_attributes_single_value import IncidentFieldAttributesSingleValue
from datadog_api_client.v2.model.incident_field_attributes_single_value_type import (
    IncidentFieldAttributesSingleValueType,
)
from datadog_api_client.v2.model.incident_type import IncidentType
from datadog_api_client.v2.model.nullable_relationship_to_user import NullableRelationshipToUser
from datadog_api_client.v2.model.nullable_relationship_to_user_data import NullableRelationshipToUserData
from datadog_api_client.v2.model.users_type import UsersType

# there is a valid "user" in the system
USER_DATA_ID = environ["USER_DATA_ID"]

body = IncidentCreateRequest(
    data=IncidentCreateData(
        type=IncidentType.INCIDENTS,
        attributes=IncidentCreateAttributes(
            title="Example-Incident",
            customer_impacted=False,
            fields=dict(
                state=IncidentFieldAttributesSingleValue(
                    type=IncidentFieldAttributesSingleValueType.DROPDOWN,
                    value="resolved",
                ),
            ),
        ),
        relationships=IncidentCreateRelationships(
            commander_user=NullableRelationshipToUser(
                data=NullableRelationshipToUserData(
                    type=UsersType.USERS,
                    id=USER_DATA_ID,
                ),
            ),
        ),
    ),
)

configuration = Configuration()
configuration.unstable_operations["create_incident"] = True
with ApiClient(configuration) as api_client:
    api_instance = IncidentsApi(api_client)
    response = api_instance.create_incident(body=body)

    print(response)
```

#### Instructions

First [install the library and its dependencies](https://docs.datadoghq.com/api/latest.md?code-lang=python) and then save the example to `example.py` and run following commands:
    DD_SITE="datadoghq.com" DD_API_KEY="<DD_API_KEY>" DD_APP_KEY="<DD_APP_KEY>" python3 "example.py"
##### 

```ruby
# Create an incident returns "CREATED" response

require "datadog_api_client"
DatadogAPIClient.configure do |config|
  config.unstable_operations["v2.create_incident".to_sym] = true
end
api_instance = DatadogAPIClient::V2::IncidentsAPI.new

# there is a valid "user" in the system
USER_DATA_ID = ENV["USER_DATA_ID"]

body = DatadogAPIClient::V2::IncidentCreateRequest.new({
  data: DatadogAPIClient::V2::IncidentCreateData.new({
    type: DatadogAPIClient::V2::IncidentType::INCIDENTS,
    attributes: DatadogAPIClient::V2::IncidentCreateAttributes.new({
      title: "Example-Incident",
      customer_impacted: false,
      fields: {
        state: DatadogAPIClient::V2::IncidentFieldAttributesSingleValue.new({
          type: DatadogAPIClient::V2::IncidentFieldAttributesSingleValueType::DROPDOWN,
          value: "resolved",
        }),
      },
    }),
    relationships: DatadogAPIClient::V2::IncidentCreateRelationships.new({
      commander_user: DatadogAPIClient::V2::NullableRelationshipToUser.new({
        data: DatadogAPIClient::V2::NullableRelationshipToUserData.new({
          type: DatadogAPIClient::V2::UsersType::USERS,
          id: USER_DATA_ID,
        }),
      }),
    }),
  }),
})
p api_instance.create_incident(body)
```

#### Instructions

First [install the library and its dependencies](https://docs.datadoghq.com/api/latest.md?code-lang=ruby) and then save the example to `example.rb` and run following commands:
    DD_SITE="datadoghq.com" DD_API_KEY="<DD_API_KEY>" DD_APP_KEY="<DD_APP_KEY>" rb "example.rb"
##### 

```rust
// Create an incident returns "CREATED" response
use datadog_api_client::datadog;
use datadog_api_client::datadogV2::api_incidents::IncidentsAPI;
use datadog_api_client::datadogV2::model::IncidentCreateAttributes;
use datadog_api_client::datadogV2::model::IncidentCreateData;
use datadog_api_client::datadogV2::model::IncidentCreateRelationships;
use datadog_api_client::datadogV2::model::IncidentCreateRequest;
use datadog_api_client::datadogV2::model::IncidentFieldAttributes;
use datadog_api_client::datadogV2::model::IncidentFieldAttributesSingleValue;
use datadog_api_client::datadogV2::model::IncidentFieldAttributesSingleValueType;
use datadog_api_client::datadogV2::model::IncidentType;
use datadog_api_client::datadogV2::model::NullableRelationshipToUser;
use datadog_api_client::datadogV2::model::NullableRelationshipToUserData;
use datadog_api_client::datadogV2::model::UsersType;
use std::collections::BTreeMap;

#[tokio::main]
async fn main() {
    // there is a valid "user" in the system
    let user_data_id = std::env::var("USER_DATA_ID").unwrap();
    let body = IncidentCreateRequest::new(
        IncidentCreateData::new(
            IncidentCreateAttributes::new(false, "Example-Incident".to_string()).fields(
                BTreeMap::from([(
                    "state".to_string(),
                    IncidentFieldAttributes::IncidentFieldAttributesSingleValue(Box::new(
                        IncidentFieldAttributesSingleValue::new()
                            .type_(IncidentFieldAttributesSingleValueType::DROPDOWN)
                            .value(Some("resolved".to_string())),
                    )),
                )]),
            ),
            IncidentType::INCIDENTS,
        )
        .relationships(IncidentCreateRelationships::new(Some(
            NullableRelationshipToUser::new(Some(NullableRelationshipToUserData::new(
                user_data_id.clone(),
                UsersType::USERS,
            ))),
        ))),
    );
    let mut configuration = datadog::Configuration::new();
    configuration.set_unstable_operation_enabled("v2.CreateIncident", true);
    let api = IncidentsAPI::with_config(configuration);
    let resp = api.create_incident(body).await;
    if let Ok(value) = resp {
        println!("{:#?}", value);
    } else {
        println!("{:#?}", resp.unwrap_err());
    }
}
```

#### Instructions

First [install the library and its dependencies](https://docs.datadoghq.com/api/latest.md?code-lang=rust) and then save the example to `src/main.rs` and run following commands:
    DD_SITE="datadoghq.com" DD_API_KEY="<DD_API_KEY>" DD_APP_KEY="<DD_APP_KEY>" cargo run
##### 

```typescript
/**
 * Create an incident returns "CREATED" response
 */

import { client, v2 } from "@datadog/datadog-api-client";

const configuration = client.createConfiguration();
configuration.unstableOperations["v2.createIncident"] = true;
const apiInstance = new v2.IncidentsApi(configuration);

// there is a valid "user" in the system
const USER_DATA_ID = process.env.USER_DATA_ID as string;

const params: v2.IncidentsApiCreateIncidentRequest = {
  body: {
    data: {
      type: "incidents",
      attributes: {
        title: "Example-Incident",
        customerImpacted: false,
        fields: {
          state: {
            type: "dropdown",
            value: "resolved",
          },
        },
      },
      relationships: {
        commanderUser: {
          data: {
            type: "users",
            id: USER_DATA_ID,
          },
        },
      },
    },
  },
};

apiInstance
  .createIncident(params)
  .then((data: v2.IncidentResponse) => {
    console.log(
      "API called successfully. Returned data: " + JSON.stringify(data)
    );
  })
  .catch((error: any) => console.error(error));
```

#### Instructions

First [install the library and its dependencies](https://docs.datadoghq.com/api/latest.md?code-lang=typescript) and then save the example to `example.ts` and run following commands:
    DD_SITE="datadoghq.com" DD_API_KEY="<DD_API_KEY>" DD_APP_KEY="<DD_APP_KEY>" tsc "example.ts"
{% /tab %}
